(function(exports) {
    exports.heat_lines_count = 6
    exports.index_multiply = 0x100
    exports.device_name = "HCR_06FV2"
    exports.is_show_lines_mode = false

    exports.add_configuration = function()
    {
        let index_multiply = {
            "type": "index multiply", 
            "count": exports.heat_lines_count, 
            "multiply_coefficient": exports.index_multiply,
            "templates":[
                {"index": "B001_2", "template": "change_value", "commands": templates_commands.line_mode_status()},
                {"index": "B021_3", "template": "control_mode", "commands": templates_commands.line_mode()},
                {"index": "B020_1", "template": "combobox", "commands": templates_commands.line_command()},
                {"index": "B021_7","template": "combobox", "commands": templates_commands.temperature_mode()},
                {"index": "B001_1","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B002_2","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B002_3","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B002_4","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B002_5","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B002_6","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B002_7","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B002_8","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B002_9","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B002_10","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B003_2","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B003_3","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B003_4","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B003_5","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B006_2","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B006_3","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B006_4","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B006_5","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B006_6","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B006_7","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B007_2","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B007_3","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B007_4","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B008_2","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B008_3","template": "change_value", "commands": templates_commands.alarm_trip_present()},
                {"index": "B02B_3","template": "combobox", "commands": templates_commands.sensors_number_hcr_06()},
                {"index": "B02B_4","template": "combobox", "commands": templates_commands.sensors_number_hcr_06()},
                {"index": "B02B_10","template": "combobox", "commands": templates_commands.sensors_number_hcr_06()},
                {"index": "B028_1","template": "combobox", "commands": templates_commands.temp_trip_mode()},
                {"index": "B028_2","template": "combobox", "commands": templates_commands.temp_trip_mode()},
                {"index": "B028_3","template": "combobox", "commands": templates_commands.temp_trip_mode()},
                {"index": "B029_1","template": "combobox", "commands": templates_commands.current_trip_mode()},
                {"index": "B029_2","template": "combobox", "commands": templates_commands.current_trip_mode()},
                {"index": "B021_4","template": "combobox", "commands": templates_commands.emergency_mode()},
        ]}
        let subindex_multiply = {
            "type": "subindex multiply",
            "count": exports.heat_lines_count, 
            "templates":[
                {"index": "3F26", "template": "combobox", "commands": templates_commands.heater_output_mode()},
                {"index": "3F28", "template": "change_value", "commands": templates_commands.no_nc()},
                {"index": "3F0F","template": "change_value", "commands": templates_commands.do_channel_status()},
        ]}
        configuration.add_multiply_templates(index_multiply)
        configuration.add_multiply_templates(subindex_multiply)

        configuration.add_template({"index": "500F_1","template": "combobox", "commands": templates_commands.lines_mode()})
    }

    exports.hide_fields_indexes = [
        {index: 0xB011, sub: 2},
        {index: 0xB003, sub: 4},
        {index: 0xB008, sub: 3},
        {index: 0xB021, sub: 1},
        {index: 0xB029, sub: 2},
        {index: 0xB023, sub: 3},
        {index: 0xB02A, sub: 5},
        {index: 0xB02A, sub: 6},
        {index: 0xB006, sub: 3},
        {index: 0xB006, sub: 4},
        {index: 0xB006, sub: 5},
    ]
})(this.app_sw_config = {})